import { HttpHeaders, HttpParams } from '@angular/common/http';
import { ProviderActionEnum } from '../enums/provider-action.enum';
import { IRestProviderActionHandlers } from '../interfaces/rest-provider-action-handlers';
import { IRestProviderOptions } from '../interfaces/rest-provider-options';
import { PaginationMeta } from '../models/pagination-meta';
export declare class RestProviderActionHandlers implements IRestProviderActionHandlers {
    getRequest(requestUrl: string, data: any, requestOptions: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        observe?: string;
        params?: HttpParams | {
            [param: string]: string | string[];
        };
        reportProgress?: boolean;
        responseType?: string;
        withCredentials?: boolean;
    }, optionsList: IRestProviderOptions<any>[], action: ProviderActionEnum, useDefault?: boolean): any;
    getResponseData(data: any, optionsList: IRestProviderOptions<any>[], action: ProviderActionEnum, useDefault?: boolean): any;
    getResponsePaginationMeta(data: any, optionsList: IRestProviderOptions<any>[], action: ProviderActionEnum, useDefault?: boolean): PaginationMeta;
    getRequestQuery(currentUrl: string, filter: any, optionsList: IRestProviderOptions<any>[], action: ProviderActionEnum, useDefault?: boolean): any;
    getRequestUrl(key: number | string, data: any, optionsList: IRestProviderOptions<any>[], action: ProviderActionEnum, useDefault?: boolean): any;
    getRequestOptions(key: number | string, data: any, optionsList: IRestProviderOptions<any>[], action: ProviderActionEnum, useDefault?: boolean): any;
    getRequestCreateType(optionsList: IRestProviderOptions<any>[], action: ProviderActionEnum, useDefault?: boolean): 'create' | 'append';
}
