import { HttpHeaders, HttpParams } from '@angular/common/http';
import { Observable } from 'rxjs';
import { IHttpClient } from '../interfaces/http-client';
export interface IFakeHttpClientOptions {
    idField?: string;
    apiUrlPrefix?: string;
    pageQueryParam?: string;
    limitQueryParam?: string;
    searchTextQueryParam?: string;
}
export declare class FakeHttpClient implements IHttpClient {
    private _idField;
    private _apiUrlPrefix;
    private _pageQueryParam;
    private _limitQueryParam;
    private _searchTextQueryParam;
    private mockedItems;
    constructor(items?: any[], options?: IFakeHttpClientOptions);
    setItems(items: any[]): void;
    genId(): number;
    parseUrl(url: string, data?: string): {
        name: string;
        key: string | number;
        query: any;
        uri: any;
        page: string | number;
        limit: string | number;
        searchText: string;
    };
    checkWordInData(data: any, word: string): any;
    get<T = any>(url: string, options?: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        observe?: 'response';
        params?: HttpParams | {
            [param: string]: string | string[];
        };
        reportProgress?: boolean;
        responseType?: 'json';
        withCredentials?: boolean;
    }): Observable<any>;
    post<T = any>(url: string, body: any, options?: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        observe?: 'response';
        params?: HttpParams | {
            [param: string]: string | string[];
        };
        reportProgress?: boolean;
        responseType?: 'json';
        withCredentials?: boolean;
    }): Observable<any>;
    put<T = any>(url: string, body: any, options?: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        observe?: 'body';
        params?: HttpParams | {
            [param: string]: string | string[];
        };
        reportProgress?: boolean;
        responseType?: 'json';
        withCredentials?: boolean;
    }): Observable<any>;
    delete<T = any>(url: string, options?: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        observe?: 'response';
        params?: HttpParams | {
            [param: string]: string | string[];
        };
        reportProgress?: boolean;
        responseType?: 'json';
        withCredentials?: boolean;
    }): Observable<any>;
    patch<T = any>(url: string, body: any, options?: {
        headers?: HttpHeaders | {
            [header: string]: string | string[];
        };
        observe?: 'response';
        params?: HttpParams | {
            [param: string]: string | string[];
        };
        reportProgress?: boolean;
        responseType?: 'json';
        withCredentials?: boolean;
    }): Observable<any>;
}
